<template>
  <div class="camerasMg">
    <el-row class="topBar">
      <el-col>
        <el-form :inline="true" :model="searchData">
          <el-form-item label>
            <el-input v-model="searchData.planTitle" placeholder="请输预案标题"></el-input>
          </el-form-item>
          <el-form-item label>
            <el-select v-model="searchData.planLevel" placeholder="请输预案等级">
              <el-option label="Ⅰ级" value="Ⅰ"></el-option>
              <el-option label="Ⅱ级" value="Ⅱ"></el-option>
              <el-option label="Ⅲ级" value="Ⅲ"></el-option>
            </el-select>            
          </el-form-item>
          <el-form-item>
            <el-button type="primary" @click="searchFun()">
              <i class="el-icon-search"></i> 搜索
            </el-button>
            <el-button type="primary" @click="resetFun()">
              <i class="el-icon-refresh"></i> 重置
            </el-button>
          </el-form-item>
          <el-form-item class="fr">
            <el-button plain type="primary" @click="addFun()">
              <i class="el-icon-plus"></i> 添加预案
            </el-button>
          </el-form-item>
        </el-form>
      </el-col>
    </el-row>
    <el-table :data="tableData.pageData" stripe border style="width:100%;" :loading="false">
      <el-table-column width="50" type="index" label="序号"></el-table-column>
      <el-table-column prop="planTitle" label="预案标题"></el-table-column>
      <el-table-column prop="planLevel" label="预案等级">
        <template slot-scope="scope">
          <font>{{scope.row.planLevel + '级'}}</font>
        </template>
      </el-table-column>
      <el-table-column prop="planType" label="预案分类"></el-table-column>
      <el-table-column prop="deptName" label="所属部门"></el-table-column>
      <el-table-column prop="createTime" label="创建时间"></el-table-column>
      <el-table-column label="操作" width="200" align="center">
        <template slot-scope="scope">
          <el-button @click="editFun(scope.row)" size="small">
            <i class="el-icon-edit-outline"></i> 编辑
          </el-button>
          <el-button type="danger" @click="delFun(scope.row)" size="small">
            <i class="el-icon-delete"></i> 删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      background
      layout="total,sizes, prev, pager, next, jumper"
      :total="tableData.total"
      @size-change="handleSizeChange"
      @current-change="handleCurrentChange"
      :current-page="PAGE.page"
      :page-size="PAGE.size"
    ></el-pagination>
    <PlansMgEdit
      v-if="dialogVisible"
      :dialogVisible="dialogVisible"
      :id="formData.id"
      :title="dialogTit"
      @dialogFun="closeDialog"
      @refreshTableData="getTableData"
      :key="zjKey"
    ></PlansMgEdit>
  </div>
</template>
<script lang="ts">
import { Component, Vue, Provide } from "vue-property-decorator";
import PlansMgEdit from "./PlansMgEdit.vue";
import METHOD from "@/utils/methods";
@Component({
  components: { PlansMgEdit }
})
export default class CamerasMg extends Vue {
  @Provide() signId: String = "";
  @Provide() tableData: Object = { pageData: [], total: 0 };
  @Provide() PAGE: any = { page: 1, size: 10 };
  @Provide() searchData: any = {  };
  @Provide() loading: Boolean = false;
  //编辑组件
  @Provide() dialogVisible: Boolean = false;
  @Provide() dialogTit: String = "新增预案";
  @Provide() formData: Object = {};
  @Provide() zjKey: any = 0;
  getTableData() {
    let that = this,
      params = Object.assign(that.PAGE, that.searchData);
    (that as any).$axios
      .post("/planInfo/getPlanInfoList", params)
      .then((res: any) => {
        if( res ) that.tableData = res;
      });
  }
  searchFun() {
    this.PAGE = { page: 1, size: 10 };
    this.getTableData();
  }
  resetFun() {
    this.PAGE = { page: 1, size: 10 };
    this.searchData = {};
    this.getTableData();
  }
  addFun() {
    this.zjKey++;
    this.dialogVisible = true;
  }
  editFun(row: any) {
    this.dialogTit = "编辑预案";
    this.formData = Object.assign({}, row);
    this.zjKey++;
    this.dialogVisible = true;
  }
  delFun(row: any) {
    let that = this as any;
    METHOD.deleteFun(that, `/planInfo/deletePlanInfoById/${row.id}`, function() {
      that.getTableData();
    });
  }
  handleSizeChange(val: any) {
    this.PAGE.size = val;
    this.getTableData();
  }
  handleCurrentChange(val: any) {
    this.PAGE.page = val;
    this.getTableData();
  }
  closeDialog() {
    //关闭窗口
    this.dialogVisible = false;
    this.formData = {};
  }
  created() {
    this.getTableData();
  }
}
</script>
